        let fish_completer = {|spans|
            let completions = fish --command $'complete "--do-complete=($spans | str join " ")"'
            | from tsv --flexible --noheaders --no-infer
            | rename value description

            let has_paths = ($completions | any {|row| $row.value =~ '/' or $row.value =~ '\\.\\w+$' or $row.value =~ ' '})

            if $has_paths {
                $completions | update value {|row|
                    if $row.value =~ ' ' {
                        $"'($row.value)'"  # Wrap in single quotes
                    } else {
                        $row.value
                    }
                }
            } else {
                $completions
            }
         }

let zoxide_completer = {|spans|
    $spans | skip 1 | zoxide query -l ...$in | lines | each {|line| $line | str replace $env.HOME '~' } | where {|x| $x != $env.PWD}
}

let external_completer = {|spans|

  match $spans.0 {

# use zoxide completions for zoxide commands
    z | zi => $zoxide_completer
    __zoxide_z | __zoxide_zi => $zoxide_completer
    _ => $fish_completer
  } | do $in $spans
}
